package com.repair.controller;


import com.repair.api.RepairReceivingControllerAPI;
import com.repair.common.utils.paramUtils;
import com.repair.model.pojo.RepairReceiving;
import com.repair.model.result.CommonResult;
import com.repair.model.result.PageUtils;
import com.repair.services.RepairReceivingService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author ceshi
 * @since 2023-07-20
 */
@RestController
public class RepairReceivingController implements RepairReceivingControllerAPI {

    @Autowired
    private RepairReceivingService repairReceivingService;

    /**
     * 新增接单数据
     * @param rc 判单数据
     * @param bindingResult 是否为空判断
     * @return
     */
    @Override
    public CommonResult insertRepairReceiving(RepairReceiving rc, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            String st = paramUtils.getParamError(bindingResult);
            return CommonResult.fail(st);
        }

        int result = repairReceivingService.insertRepairReceiving(rc);

        return result > 0 ? CommonResult.ok("添加成功") : CommonResult.fail("添加失败");
    }

    /**
     * 根据数据ID更新接单数据
     * @param rc 接单数据
     * @param bindingResult 是否为空判断
     * @return
     */
    @Override
    public CommonResult updateRepairReceivingById(RepairReceiving rc, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            String st = paramUtils.getParamError(bindingResult);
            return CommonResult.fail(st);
        }

        int result = repairReceivingService.updateRepairReceiving(rc);

        return result > 0 ? CommonResult.ok("修改成功") : CommonResult.fail("修改失败");
    }

    /**
     * 接单分页数据查询
     * @param currentPage 当前页数
     * @param pageCount 一页数据条数
     * @param name 查询名称
     * @return
     */
    @Override
    public CommonResult queryPageRepairReceivings(int currentPage, int pageCount, String name) {
        PageUtils<RepairReceiving> result = repairReceivingService.queryPageRepairReceivings(currentPage, pageCount, name);

        return CommonResult.ok(result);
    }

    /**
     * 根据数据ID删除接单数据
     * @param id 数据ID
     * @return
     */
    @Override
    public CommonResult deleteRepairReceivingById(int id) {
        RepairReceiving data = repairReceivingService.getRepairById(id);
        if (data == null) {
            return CommonResult.fail("当前数据不存在，删除失败！");
        }

        int result = repairReceivingService.deleteRepairReceivingById(id);

        return result > 0 ? CommonResult.ok("删除成功") : CommonResult.fail("删除失败");
    }
}

